//Programm arvutab Kuu umbkaudse kauguse Maast olenevalt kuupevast 
//ja laseb kasutajal seda arvata
//Kasutajalt nutav tpsus on 1000km
//Programm ksitleb aega peva tpsusega
//Eeldused: min kaugus on 363300 km, max kaugus on 405500km
//max kaugus on umbes kuupeval 16.01.2010
//kuu teeb tistiiru 27.321661 pevaga
#include <stdio.h>
#include <time.h>

int maxkaugus=405500;
int minkaugus=363300;
float taistiir=27.321661;


int aastaseadistamine(){
int aasta;
do{
           printf("Sisesta aasta (1-3000)\n>>");
           scanf("%i",&aasta);
        }while(aasta<1||aasta>3000);
return aasta;
}
//laseb kasutajal valida kuupeva
int kuupaevaseadistamine(int aasta){
    int kuu, paev, paevamax=28;
    int liigaasta=0;
        //kontrollib, kas on tegemist liigaastaga
        if((aasta%4==0&&aasta%100!=0)||aasta%400==0){liigaasta=1;paevamax=29;}
        do{
           printf("Sisesta kuu (1-12)\n>>");
           scanf("%i",&kuu);
        }while(kuu<1||kuu>12);
        switch (kuu){
               case 4: paevamax=30; break;
               case 6: paevamax=30; break;
               case 9: paevamax=30; break;
               case 11: paevamax=30; break;
               default : paevamax=31; break;
        }
        do{
           printf("Sisesta pev\n>>");
           scanf("%i",&paev);
        }while(paev<1||paev>paevamax);
    return paev, kuu, aasta; 
}

//leiab pevade arvu eelnenud kuudes
int paevikuudes(int kuunr, int aasta){
int paevi=0;
kuunr-=1;
switch (kuunr){
       case 11:paevi+=30;
       case 10:paevi+=31;
       case 9:paevi+=30;
       case 8:paevi+=31;
       case 7:paevi+=31;
       case 6:paevi+=30;
       case 5:paevi+=31;
       case 4:paevi+=30;
       case 3:paevi+=31;
       case 2:if((aasta%4==0&&aasta%100!=0)||aasta%400==0){paevi+=29;}else{paevi+=28;}
       case 1:paevi+=31;
       }
return paevi;
}

//leiab ajavahemiku kahe kuupeva vahel pevades
int arvutaajavahemik(int paev1, int kuu1, int aasta1, int paev2, int kuu2, int aasta2){
int paeva=0;
int onsuurem=0;
    if(aasta2>aasta1){onsuurem=1;}
    if(aasta1==aasta2&&kuu2>kuu1){onsuurem=1;}
    if(aasta1==aasta2&&kuu1==kuu2&&paev2>paev1){onsuurem=1;}
    if(onsuurem==1){
        paeva=paev2-paev1;
        paeva+=paevikuudes(kuu2, aasta2)-paevikuudes(kuu1, aasta1);
        for (int i=aasta1;i<aasta2;i++){
            paeva+=365;
            if((i%4==0&&i%100!=0)||i%400==0){paeva+=1;}      
        }
    if(kuu1>2&&((aasta1%4==0&&aasta1%100!=0)||aasta1%400==0)){paeva-=1;}
    }
    else{
         paeva=paev1-paev2;
         paeva+=paevikuudes(kuu1, aasta1)-paevikuudes(kuu2, aasta2);
         for (int i=aasta2;i<aasta1;i++){
             paeva+=365;
             if((i%4==0&&i%100!=0)||i%400==0){paeva+=1;} 
         }  
         if(kuu2>2&&((aasta2%4==0&&aasta2%100!=0)||aasta2%400==0)){paeva-=1;}            
    }
return paeva;
}

//arvutab Kuu ja Maa vahelise kauguse teades kuupevade vahet
int arvutakaugus(int ajavahemik){
int kaugus;
kaugus=ajavahemik/taistiir;
if (kaugus*taistiir>ajavahemik){kaugus-=1;}
if(ajavahemik/taistiir-kaugus>taistiir/2){
   kaugus=maxkaugus-(ajavahemik/taistiir-kaugus)*(maxkaugus-minkaugus);                                         
}
else{
     kaugus=minkaugus+(ajavahemik/taistiir-kaugus)*(maxkaugus-minkaugus);
}
return kaugus;
}

int menuu(){
time_t praegu;
struct tm *aeg;
char kuupaev[13];
time(&praegu);
aeg = localtime(&praegu);
strftime(kuupaev, 15, "%d.%m.%Y", aeg);

int katkesta=0;
int vastus;
int aasta, kuu, paev;
int tegelikkaugus;
int arvatiara=0;
int piirmax, piirmin;
                  do{                 
                     do{
                        printf("Tnane kuupev on %s\n", kuupaev);
                        printf("Sisesta 1 kui soovid arvata tnase kuupeva kohta\n");
                        printf("Sisesta 2 kui soovid kuupeva ise seadistada\n>>");
                        scanf("%i",&vastus);    
                     }while(vastus<0||vastus>2);
                     if (vastus==0){katkesta=1;}
                     else if (vastus==2){aasta=aastaseadistamine(); paev, kuu=kuupaevaseadistamine(aasta);}        
                     else {
                          paev=(kuupaev[0]-48)*10+kuupaev[1]-48;
                          kuu=(kuupaev[3]-48)*10+kuupaev[4]-48;
                          aasta=(kuupaev[6]-48)*1000+(kuupaev[7]-48)*100+(kuupaev[8]-48)*10+kuupaev[9]-48;
                          }
                     if (katkesta==0){                      
                        tegelikkaugus=arvutakaugus(arvutaajavahemik(paev, kuu, aasta, 16, 1, 2010));
                        printf("Arvake Kuu ja Maa vahelist kaugust\n>>");
                        scanf("%i",&vastus);
                        for(int i=0;(vastus<minkaugus||vastus>maxkaugus)&&i<7;i++){
                                printf("Sellisel kaugusel pole Kuu oma mistahes asukohas orbiidil.\n");
                                printf("Teie pakkumine on tegelikust ");
                                if (vastus<minkaugus){printf("viksem.\n");}
                                if (vastus>maxkaugus){printf("suurem.\n");}
                                printf("Arvake uuesti\n>>");
                                scanf("%i",&vastus);
                        }
                        if (vastus<minkaugus||vastus>maxkaugus){
                           printf("Kuu maksimaalne kaugus Maast on %i km ja minimaalne on %i km\n",maxkaugus,minkaugus);
                           printf("Palun edaspidi teha pakkumisi sellest vahemikust");
                        }
                        else {printf("Saite pihta Kuu vimalikule kaugusele.");}
                        int j=0;
                        int lahimpakkumine=0;
                        do{
                            printf("\nArvake tpsemat Kuu hetkekaugust\n>>");
                            scanf("%i",&vastus);
                            j++;
                                if ((vastus-tegelikkaugus)<=1000&&(vastus-tegelikkaugus)>=-1000){
                                arvatiara=1;
                                }
                                if ((vastus-tegelikkaugus)>0&&(lahimpakkumine-tegelikkaugus)>0){
                                   if ((vastus-tegelikkaugus)<(lahimpakkumine-tegelikkaugus)){
                                   lahimpakkumine=vastus;
                                   }
                                }
                                if ((vastus-tegelikkaugus)>0&&(tegelikkaugus-lahimpakkumine)>0){
                                   if ((vastus-tegelikkaugus)<(tegelikkaugus-lahimpakkumine)){
                                   lahimpakkumine=vastus;
                                   }
                                }
                                if ((tegelikkaugus-vastus)>0&&(lahimpakkumine-tegelikkaugus)>0){
                                   if ((tegelikkaugus-vastus)<(lahimpakkumine-tegelikkaugus)){
                                   lahimpakkumine=vastus;
                                   }
                                }
                                if ((tegelikkaugus-vastus)>0&&(tegelikkaugus-lahimpakkumine)>0){
                                   if ((tegelikkaugus-vastus)<(tegelikkaugus-lahimpakkumine)){
                                   lahimpakkumine=vastus;
                                   }
                                }
                                if (arvatiara==0&&j>1){
                                printf("Lhim pakkumine on olnud %i",lahimpakkumine);
                                }
                        }while(arvatiara==0&&j<9);
                        if(arvatiara==0){printf("\nEi pdnud seekord Kuud kinni:(\n");}
                        else {printf("\nnnitlused, arvasite ra ige Kuu hetkekauguse!\n");}
                     }
                  }
                  while(katkesta!=1);   
return 0;
}

int main(){
printf("Programm laseb arvata Kuu kaugust Maast.\n");
printf("Pakkuda tuleb kilomeetrites ning igeks loetakse vastus 1000 kilomeetri tpsusega.\n");
printf("Sulgemiseks sisestada 0\n");
menuu();
return 0;
}

